
# This file is automatically generated, you probably don't want to edit this

#' @importFrom jmvcore Options
#' @importFrom R6 R6Class
contTablesPairedOptions <- R6::R6Class(
    "contTablesPairedOptions",
    inherit = jmvcore::Options,
    public = list(
        initialize = function(
            rows = NULL,
            cols = NULL,
            counts = NULL,
            pcRow = FALSE,
            pcCol = FALSE, ...) {

            super$initialize(
                package='jmv',
                name='contTablesPaired',
                requiresData=TRUE,
                ...)
        
            private$..rows <- jmvcore::OptionVariable$new(
                "rows",
                rows,
                suggested=list(
                    "nominal",
                    "ordinal"))
            private$..cols <- jmvcore::OptionVariable$new(
                "cols",
                cols,
                suggested=list(
                    "nominal",
                    "ordinal"))
            private$..counts <- jmvcore::OptionVariable$new(
                "counts",
                counts,
                suggested=list(
                    "continuous"),
                permitted=list(
                    "continuous",
                    "nominal",
                    "ordinal"),
                default=NULL)
            private$..pcRow <- jmvcore::OptionBool$new(
                "pcRow",
                pcRow,
                default=FALSE)
            private$..pcCol <- jmvcore::OptionBool$new(
                "pcCol",
                pcCol,
                default=FALSE)
        
            self$.addOption(private$..rows)
            self$.addOption(private$..cols)
            self$.addOption(private$..counts)
            self$.addOption(private$..pcRow)
            self$.addOption(private$..pcCol)
        }),
    active = list(
        rows = function() private$..rows$value,
        cols = function() private$..cols$value,
        counts = function() private$..counts$value,
        pcRow = function() private$..pcRow$value,
        pcCol = function() private$..pcCol$value),
    private = list(
        ..rows = NA,
        ..cols = NA,
        ..counts = NA,
        ..pcRow = NA,
        ..pcCol = NA)
)

#' @import jmvcore
#' @importFrom R6 R6Class
contTablesPairedResults <- R6::R6Class(
    inherit = jmvcore::Group,
    active = list(
        freqs = function() private$..freqs,
        test = function() private$..test),
    private = list(
        ..freqs = NA,
        ..test = NA),
    public=list(
        initialize=function(options) {
            super$initialize(options=options, name="", title="Paired Samples Contingency Tables")
            private$..freqs <- jmvcore::Table$new(
                options=options,
                name="freqs",
                title="Contingency Tables",
                columns=list(),
                clearWith=list(
                    "rows",
                    "cols",
                    "counts"))
            private$..test <- jmvcore::Table$new(
                options=options,
                name="test",
                title="McNemar Test",
                clearWith=list(
                    "rows",
                    "cols",
                    "counts"),
                columns=list(
                    list(`name`="name[mcn]", `title`="", `type`="text", `content`="\u03C7\u00B2"),
                    list(`name`="value[mcn]", `title`="Value"),
                    list(`name`="df[mcn]", `title`="df", `type`="integer"),
                    list(`name`="p[mcn]", `title`="p", `type`="number", `format`="zto,pvalue"),
                    list(`name`="name[cor]", `title`="", `type`="text", `content`="\u03C7\u00B2 continuity correction"),
                    list(`name`="value[cor]", `title`="Value"),
                    list(`name`="df[cor]", `title`="df", `type`="integer"),
                    list(`name`="p[cor]", `title`="p", `type`="number", `format`="zto,pvalue")))
            self$add(private$..freqs)
            self$add(private$..test)}))

#' @importFrom jmvcore Analysis
#' @importFrom R6 R6Class
contTablesPairedBase <- R6::R6Class(
    "contTablesPairedBase",
    inherit = jmvcore::Analysis,
    public = list(
        initialize = function(options, data=NULL, datasetId="", analysisId="", revision=0) {
            super$initialize(
                package = 'jmv',
                name = 'contTablesPaired',
                version = c(1,0,0),
                options = options,
                results = contTablesPairedResults$new(options=options),
                data = data,
                datasetId = datasetId,
                analysisId = analysisId,
                revision = revision,
                pause = NULL,
                completeWhenFilled = TRUE)
        }))

#' Paired Samples Contingency Tables
#'
#' McNemar test
#'
#' @examples
#' \dontrun{
#' contTablesPaired(data, rows='x', cols='y')
#' }
#' @param data the data as a data frame
#' @param rows a string naming the variable to use as the rows in the 
#'   contingency table 
#' @param cols a string naming the variable to use as the columns in the 
#'   contingency table 
#' @param counts a string naming the variable to use as counts, or NULL if 
#'   each row represents a single observation 
#' @param pcRow \code{TRUE} or \code{FALSE} (default), provide row percentages 
#' @param pcCol \code{TRUE} or \code{FALSE} (default), provide column 
#'   percentages 
#' @export
contTablesPaired <- function(
    data,
    rows,
    cols,
    counts = NULL,
    pcRow = FALSE,
    pcCol = FALSE) {

    options <- contTablesPairedOptions$new(
        rows = rows,
        cols = cols,
        counts = counts,
        pcRow = pcRow,
        pcCol = pcCol)

    results <- contTablesPairedResults$new(
        options = options)

    analysis <- contTablesPairedClass$new(
        options = options,
        data = data)

    analysis$run()
    analysis$render()

    analysis$results
}
