
# This file is automatically generated, you probably don't want to edit this

#' @importFrom jmvcore Options
#' @importFrom R6 R6Class
linRegOptions <- R6::R6Class(
    "linRegOptions",
    inherit = jmvcore::Options,
    public = list(
        initialize = function(
            dep = NULL,
            cov = NULL, ...) {

            super$initialize(
                package='jmv',
                name='linReg',
                requiresData=TRUE,
                ...)
        
            private$..dep <- jmvcore::OptionVariable$new(
                "dep",
                dep,
                suggested=list(
                    "continuous"),
                permitted=list(
                    "continuous",
                    "nominal",
                    "ordinal"))
            private$..cov <- jmvcore::OptionVariables$new(
                "cov",
                cov,
                suggested=list(
                    "continuous"),
                permitted=list(
                    "continuous",
                    "nominal",
                    "ordinal"))
        
            self$.addOption(private$..dep)
            self$.addOption(private$..cov)
        }),
    active = list(
        dep = function() private$..dep$value,
        cov = function() private$..cov$value),
    private = list(
        ..dep = NA,
        ..cov = NA)
)

#' @import jmvcore
#' @importFrom R6 R6Class
linRegResults <- R6::R6Class(
    inherit = jmvcore::Group,
    active = list(
        table = function() private$..table),
    private = list(
        ..table = NA),
    public=list(
        initialize=function(options) {
            super$initialize(options=options, name="", title="Linear Regression")
            private$..table <- jmvcore::Table$new(
                options=options,
                name="table",
                title="Linear Regression",
                columns=list(
                    list(`name`="var", `title`="")))
            self$add(private$..table)}))

#' @importFrom jmvcore Analysis
#' @importFrom R6 R6Class
linRegBase <- R6::R6Class(
    "linRegBase",
    inherit = jmvcore::Analysis,
    public = list(
        initialize = function(options, data=NULL, datasetId="", analysisId="", revision=0) {
            super$initialize(
                package = 'jmv',
                name = 'linReg',
                version = c(1,0,0),
                options = options,
                results = linRegResults$new(options=options),
                data = data,
                datasetId = datasetId,
                analysisId = analysisId,
                revision = revision,
                pause = NULL,
                completeWhenFilled = TRUE)
        }))

#' Linear Regression
#'
#' 
#' @param data the data as a data frame
#' @param dep a string naming the dependent variable
#' @param cov a vector of strings naming the covariates
#' @export
linReg <- function(
    data,
    dep,
    cov) {

    options <- linRegOptions$new(
        dep = dep,
        cov = cov)

    results <- linRegResults$new(
        options = options)

    analysis <- linRegClass$new(
        options = options,
        data = data)

    analysis$run()
    analysis$render()

    analysis$results
}
